#!/usr/bin/perl -T
# $Id: ajax_desc.cgi,v 1.1 2013/08/27 11:57:33 sofc Exp $
use strict;
use warnings;
use ElchemeaHeader;
use ElchemeaUser;
use Elchemea;
use ElchemeaCGI qw(:DEFAULT :html :cgi);
use CGI qw(:standard :netscape);

print header();
my $u = param('user');
my $p = param('pass');
unless (&ElchemeaCGI::login_ok($u,$p))
{
    print "Access denied!\n";
    exit;
}
my $user = ElchemeaUser->new($u);
my $session = $user->session;
my $device = param('device');
my $key = param('key');
unless (defined($device) && $device && defined($key) && $key)
{
    print "Undefined device or key found!\n";
    $key = '' unless ($key);
    print "$key\n\n";
    exit;
}

my $warn = '';
my $pot = Elchemea::new_PSTAT(Elchemea::get_config_value('equipment','potentiostat'),Elchemea::get_config_value('equipment','potentiostat_address'));
my $fra = Elchemea::new_FRA(Elchemea::get_config_value('equipment','FRA'),Elchemea::get_config_value('equipment','FRA_address'));

my $dev = undef; 
$dev = $pot if ($device eq 'POT');
$dev = $fra if ($device eq 'FRA');

unless ($dev)
{
    print "Undefined device ('$device' not FRA or POT)\n";
    exit;
}
my $str = $dev->tag_description($key);
$str = "No description found for key '$key'" unless ($str);
print $str,"\n";
exit;
