#!/usr/bin/perl -T
# $Id: imp_conf.cgi,v 1.32 2013/08/27 12:44:32 sofc Exp $
############################################################
############################################################
###                                                      ###
###   Originally designed by Karin Soeren Koch           ###
###                                                      ###
###   Impelemented by Soeren Koch                        ###
###                                                      ###
###   Copyright by Soeren Koch January 2005              ###
###                                                      ###
############################################################
############################################################

use strict;
use warnings;
use ElchemeaHeader;
use ElchemeaUser;
use Elchemea;
use ElchemeaCGI qw(:DEFAULT :html :cgi);
use CGI qw(:standard :netscape);
my $fra = Elchemea::new_FRA(Elchemea::get_config_value('equipment','FRA'),Elchemea::get_config_value('equipment','FRA_address'));
my $pot = Elchemea::new_PSTAT(Elchemea::get_config_value('equipment','potentiostat'),Elchemea::get_config_value('equipment','potentiostat_address'));
my $user;
my $bc_admin = undef;
if (!defined(param))
{
    print_header("Please log in to the Elchemea");
    print '<center>';
    &ElchemeaCGI::login;
    print '</center>';
    &print_end;
}
else
{
    if (login_ok())
    { 
	$user = ElchemeaUser->new(param('user'));
	&ElchemeaCGI::print_header("Elchemea Impedance setup",-onload=>'load_all()');   
	top_nav_bar_start();
	param(-name=>'action',-value=>'') unless (param('action'));
	$_ = param('action');
      CASE:
	{
	    ### Insert case statements ###
	    /Show freq/ and do {&show_list; last CASE;};
	    /Advanced/ and do {&advanced(); last CASE;};
	    ### Default response ####
	    &main_page;
	}
	print_end();
    }
    else 
    {
	not_auth();
    }
}
    
exit;

sub show_list
{
    top_nav_bar_button('config.cgi','','','Manually edit configuration','s6');
    top_no_button();
    top_no_button();
    tab_newrow();
    js_back();
    top_js_return('#006600','white');
    top_nav_bar_button('','','action','Frequency setup','s5');
    top_no_button();
    top_nav_bar_button('view_session.cgi','','','Session view','s6');
    top_nav_bar_button('main.cgi','','','To menu','s4');
    end_top_bar();
    print '<center>';
    print h1("Frequency list based on current configuration");
    print '<table class="tabel"><tr>';
    print '<td width="20%"></td>';
    print '<td width="20%"></td>';
    print '<td width="20%"></td>';
    print '<td width="20%"></td>';
    print '<td width="20%"></td>';
    print '</tr>';
    print '<tr><td></td>';
    my @list = $user->get_impedance_frequencies($user->session,$pot,$fra);
    my $h = $list[0];
    foreach my $k (keys %{$h})
    {
	next if ($k eq 'integration_mode' || $k eq 'integration_number' || $k eq 'segment');
	$k =~ s/_/ /g;
	print '<th style="text-align:center;">';
	print ucfirst($k);
	print '</th>';
    }
    print '</tr>';
    foreach (@list)
    {
	print '<tr><td></td>';
	foreach my $k (keys %{$_})
	{
	    next if ($k eq 'integration_mode' || $k eq 'integration_number' || $k eq 'segment');
	    print '<td>';
	    print $$_{$k};
	    print '</td>';
	}
	print '</tr>';
    }
    print '</table></center>';
    
    print <<END;

<script language="javascript">
function load_all()
{
    /*do nothing*/
}
</script>


END

}

sub main_page
{
    top_nav_bar_button('config.cgi','','','Manually edit configuration','s6');
    top_no_button();
    top_nav_bar_button('','','action','Show frequency list','s3');
    tab_newrow();
    js_back();
    top_js_return('#006600','white');
    top_nav_bar_button('','','action','Advanced setup','s5');
    ElchemeaCGI::create_menu_field;
    print start_form(-action=>'run_imp.cgi',-name=>'run_chrono',-class=>'form',-onsubmit=>'return check_run()');
    print_hidden();
    print submit(-name=>'action',-value=>'Run impedance',-class=>'none',-id=>'run_imp');
    print end_form;
    top_nav_bar_button('view_session.cgi','','','Session view','s6');
    top_nav_bar_button('main.cgi','','','To menu','s4');
    end_top_bar();
    my $pot = Elchemea::new_PSTAT(Elchemea::get_config_value('equipment','potentiostat'),Elchemea::get_config_value('equipment','potentiostat_address'));
    my $fra = Elchemea::new_FRA(Elchemea::get_config_value('equipment','FRA'),Elchemea::get_config_value('equipment','FRA_address'));
    print '<center>';
    print '<table cellspacing=5 cellpadding=5 class="tabel"><tr>';
    print '<td width="5%"></td>';
    print '<td width="17%"></td>';
    print '<td width="10%"></td>';
    print '<td width="3%"></td>';
    print '<td width="17%"></td>';
    print '<td width="10%"></td>';
    print '<td width="3%"></td>';
    print '<td width="17%"></td>';
    print '<td width="10%"></td>';
    print '<td width="3%"></td>';
    print '<td width="5%"></td>';
    print '</tr>';
    my @list = $pot->setup_tags;
    my $is_source_mode = 0;
    my $is_pol = 0;
    foreach ($fra->setup_tags)
    {
	$is_pol = 1 if ($_ eq 'polarisation');
	$is_source_mode = 1 if ($_ eq 'source_mode');
    }
    my @poltags = ('mode','polarisation','polarisation_offset_program','reference_potential');
    foreach ($pot->frequency_segment_tags())
    {
	push @poltags,$_;
    }
    my @fratags = ('amplitude');
    if ($pot->virtual)
    {
	if ($is_pol)
	{
	    unshift @fratags,'polarisation';
	    unshift @fratags,'polarisation_offset_program';
	}
	unshift @fratags,'mode';
	push @fratags,'source_mode' if ($is_source_mode);
    }
    foreach ($fra->frequency_segment_tags)
    {
	push @fratags,$_;
    }
    my @scantags = ('sweep_segments','number_of_points_pr_decade','frequency_order','integration_type');
    my @yn = ('','Yes','No');
    my @offset_progs = Elchemea::get_dir_list('/usr/local/bin/elchemea/user_exec/','\w');
    unshift @offset_progs,'None';
    my %psetup = ();
    my %fsetup = ();
    my @cf = ();
    my $mode_pot = '';
    unless ($pot->virtual)
    {
	foreach my $tag (@poltags)
	{
	    $psetup{$tag} = $user->get_config_value('impedance_potentiostat',$tag);
	    $psetup{$tag} = $pot->get_default($tag) unless (defined($psetup{$tag}));
	}
	$mode_pot = $psetup{'mode'};
    }
    foreach my $tag (@fratags,@scantags)
    {
	$fsetup{$tag} = $user->get_config_value('impedance_FRA',$tag);
	$fsetup{$tag} = $fra->get_default($tag) unless (defined($fsetup{$tag}));
    }
    my @tags = ();
    print '<tr><td colspan=11 class="heading">Elchemea impedance setup</td></tr>';
    unless ($pot->virtual)
    {
	my $count = 0;
	foreach my $key (@poltags)
	{
	    my %labels = ();
	    print '<tr><td></td>' unless ($count);
	    print "<th onclick='get_desc(\"POT\",\"$key\")'>";
	    my $tag = $key;
	    $tag =~ s/_/ /g;
	    print ucfirst($tag);
	    print '</th><td>';
	    my @l = $pot->get_tag_values($key);
	    @l = $pot->get_modes() if ($key eq 'mode');
	    %labels = ('Volt' => 'Control Voltage', 'Amp' => 'Control current') if ($key eq 'mode');
	    @l = @offset_progs if ($key =~ /offset_prog/);
	    @l = @yn if ($key eq 'keep_potential');
	    if (@l>1 || $key eq 'mode' || $key =~ /offset_prog/)
	    {
		print popup_menu(-name=>$key,-values=>[(@l)],-class=>'textfield',-default=>$psetup{$key},-force=>1,-onchange=>'change_val(this)',-id=>$key,-labels=>\%labels);
	    }
	    else
	    {
		print textfield(-name=>$key,-value=>$psetup{$key},-class=>'textfield',-force=>1,-onchange=>'change_val(this)',-id=>$key);
	    }
	    print '</td><th id="pot_'.$key.'">';
	    $psetup{'mode'} =~ /^(\w)/;
	    my $mk = $1;
	    $_ = $tag;
	  CASE:
	    {
		/polarisation$/ and do {print $mk;push @tags,"pot_$key";};
		/resis/i and do {print 'Ohm'};
		/cur/i and do {print 'A'};
		/delay|time/ and do {print 's'};
	    }
	    print '</th>';
	    if ($count++ > 1)
	    {
		$count = 0;
		print '</tr>',"\n";
	    }
	}
    }
    my $count = 0;
    $fsetup{'mode'} = $mode_pot if ($mode_pot);
    foreach my $key (@fratags)
    {
	my %labels = ();
	print '<tr><td></td>' unless ($count);
	print "<th onclick='get_desc(\"FRA\",\"$key\")'>";
	my $tag = $key;
	$tag =~ s/_/ /g;
	print ucfirst($tag);
	print '</th><td>';
	my @l = $fra->get_tag_values($key);
	@l = $fra->get_modes() if ($key eq 'mode');
	%labels = ('Volt' => 'Control Voltage', 'Amp' => 'Control current') if ($key eq 'mode');
	@l = @offset_progs if ($key =~ /offset_prog/);
	@l = @yn if ($key eq 'keep_potential');
	if (@l>1 || $key eq 'mode' || $key eq 'source_mode' || $key =~ /offset_prog/)
	{
	    print popup_menu(-name=>$key,-values=>[(@l)],-class=>'textfield',-default=>$fsetup{$key},-force=>1,-onchange=>'change_val_fra(this)',-id=>'fra_'.$key,-labels=>\%labels);
	}
	else
	{
	    print textfield(-name=>$key,-value=>$fsetup{$key},-class=>'textfield',-force=>1,-onchange=>'change_val_fra(this)',-id=>'fra_'.$key);
	}
	print '</td><th id="label_fra_'.$key.'">';
	$fsetup{'mode'} =~ /^(\w)/;
	my $mk = $1;
	$_ = $tag;
      CASE:
	{
	    /polarisation$/ and do {print $mk;push @tags,"label_fra_$key";};
	    /ampl/ and do {print $mk;push @tags,"label_fra_$key";};
	    /resis|range/i and do {print 'Ohm'};
	    /cur/i and do {print 'A'};
	    /delay|time/ and do {print 's'};
	}
	print '</th>';
	if ($count++ > 1)
	{
	    $count = 0;
	    print '</tr>',"\n";
	}
    }
    print '<tr><td colspan=11 class="heading">Frequency setup</td></tr>';
    $count = 0;
    my $max = get_config_value('global','number_of_segments');
    $max = $fra->get_max_segments if ($max > $fra->get_max_segments);
    my @segments = (1..$max);
    foreach my $key (@scantags)
    {
	my %labels = ('normal' => 'Descending','reverse' => 'Ascending','random' => 'Random');
	print '<tr><td></td>' unless ($count);
	print "<th>";
	my $tag = $key;
	$tag =~ s/number_of_points_pr_decade/Default points \/ decade/;
	$tag =~ s/_/ /g;
	print ucfirst($tag);
	print '</th><td>';
	my @l = $fra->get_tag_values($key);
	@l = ('cycles','seconds') if ($key eq 'integration_type');
	if ($key eq 'sweep_segments')
	{
	    print popup_menu(-name=>$key,-values=>[(@segments)],-class=>'textfield',-default=>$fsetup{$key},-force=>1,-onchange=>'change_segment(this)',-id=>'fra_'.$key);
	}
	else
	{
	    if (@l>1)
	    {
		if ($key =~ /frequency/i)
		{
		    print popup_menu(-name=>$key,-values=>[(@l)],-class=>'textfield',-default=>$fsetup{$key},-force=>1,-onchange=>'change_val_fra(this)',-id=>'fra_'.$key,-labels=>\%labels);
		}
		else
		{
		    print popup_menu(-name=>$key,-values=>[(@l)],-class=>'textfield',-default=>$fsetup{$key},-force=>1,-onchange=>'change_val_fra(this)',-id=>'fra_'.$key);
		}
	    }
	    else
	    {
		print textfield(-name=>$key,-value=>$fsetup{$key},-class=>'textfield',-force=>1,-onchange=>'change_val_fra(this)',-id=>'fra_'.$key);
	    }
	}
	print '</td><th id="label_fra_'.$key.'">';
	$_ = $tag;
      CASE:
	{
	    /polarisation$/ and do {print $fsetup{'mode'};push @tags,"label_fra_$key";};
	    /ampl/ and do {print $fsetup{'mode'};push @tags,"label_fra_$key";};
	    /resis/i and do {print 'Ohm'};
	    /cur/i and do {print 'A'};
	    /delay|time/ and do {print 's'};
	}
	print '</th>';
	if ($count++ > 1)
	{
	    $count = 0;
	    print '</tr>',"\n";
	}
    }
    print '</table>';
    print "\n\n";
    #### scan segment setup ###
    print '<table cellspacing=5 cellpadding=5 class="tabel"><tr>';
    print '<td width="5%"></td>';
    print '<td width="17%"></td>';
    print '<td width="7%"></td>';
    print '<td width="7%"></td>';
    print '<td width="7%"></td>';
    print '<td width="7%"></td>';
    print '<td width="7%"></td>';
    print '<td width="7%"></td>';
    print '<td width="7%"></td>';
    print '<td width="7%"></td>';
    print '<td width="7%"></td>';
    print '<td width="7%"></td>';
    print '<td width="8%"></td>';
    print '</tr>';
    my @segtags = ();
    my @pot_tags = $pot->frequency_segment_tags();
    my @fra_tags = $fra->frequency_segment_tags();
    my %dlist = ();
    foreach my $key (@pot_tags)
    {
	my @l = $pot->get_tag_values($key);
	$dlist{$key} = \@l if (@l);
    }
    foreach my $key (@fra_tags)
    {
	my @l = $fra->get_tag_values($key);
	$dlist{$key} = \@l if (@l);
    }
    foreach my $key ('segment','integration_time','maximum_frequency','minimum_frequency','number_of_points',@pot_tags,@fra_tags)
    {
	my %labels = ('' => 'Default');
	print '<tr><td></td><th>';
	my $label = $key;
	$label =~ s/number_of_points/Points \/ decade/;
	$label =~ s/_/ /g;
	print ucfirst($label);
	print '</th>';
	foreach my $i (@segments)
	{
	    my $class = 'textfield';
	    $class = 'hidden' if ($i > $user->get_config_value('impedance_FRA','sweep_segments'));
	    if ($key =~ /segment/)
	    {
		print '<th id="label_'.$i.'" class="'.$class.'">';
		print $i;
		print '</th>';
		push @segtags,'label_'.$i;
	    }
	    else
	    {
		print '<td id="label_'.$i.'">';
		my $name = $key.'_'.$i;
		my $val = $user->get_config_value('impedance_FRA',$name);
		if (exists($dlist{$key}))
		{
		    print popup_menu(-name=>$name,-values=>[('',@{$dlist{$key}})],-class=>$class,-default=>$val,-force=>1,-onchange=>'change_val_fra(this)',-id=>'fra_'.$name,-labels=>\%labels);
		}
		else
		{
		    print textfield(-name=>$name,-value=>$val,-force=>1,-class=>$class,-onchange=>'change_val_fra(this)',-id=>'fra_'.$name);
		}
		print '</td>';
		push @segtags,'fra_'.$name;
	    }
	}
	print '</tr>';
    }
    print '</table>';
    my @l = $user->get_impedance_frequencies($user->session,$pot);
    my $time = Elchemea::format_time($fra->get_impedance_time(\@l) + $user->get_offset_program_time('impedance',$user->session));
    print h2({-id=>'impedance_time'},"Estimated time for impedance: $time");
    print '</center>';
    my $segarr = "var segs = [];\n";
    for (my $i = 0; $i < @segtags; $i++ )
    {
        $segarr .= 'segs['.$i.'] = "'.$segtags[$i].'";'."\n";
    }


    my $valuearr = "var vals = [];\n";

    for (my $i = 0; $i < @tags; $i++ )
    {
        $valuearr .= 'vals['.$i.'] = "'.$tags[$i].'";'."\n";
    }

    print <<END;

<script language="javascript">

$segarr

$valuearr

var notready = 0;
var running = 1;

function check_run()
{
    if (notready > 0)
    {
        return false;
    }
    if (running > 0)
    {
        return false;
    }
    return true;
}

function get_desc(dev,key)
{
    run_ajax('ajax_desc.cgi','&key='+key+'&device='+dev,alert);
}

function set_time(t)
{
    document.getElementById('impedance_time').innerHTML = "Estimated time for impedance: "+t;
}

function set_run()
{
    var obj = document.getElementById('run_imp');
    if (notready == 0 && running == 0)
    {
        obj.setAttribute("class","s3");
        obj.setAttribute("className","s3");
    }
    else
    {
        obj.setAttribute("class","none");
        obj.setAttribute("className","none");
    }
}

function set_status(s)
{
    var res = s.split("\\n");
    if (res[0] == "Free")
    {
        running = 0;
    }
    else
    {
        running = 1;
    }
    set_run();
}


function load_status()
{
    run_ajax('runstatus.cgi','&action=status',set_status);
    setTimeout("load_status()",1000);
}

function load_all()
{
    load_status();
}

function set_val(res)
{
    var arr = res.split("\\n");
    if (arr[0] == "OK" || arr[0] == "WARN")
    {
	if (arr[0] == "WARN")
	{
	    alert(arr[4]);
	}
        var obj = document.getElementById(arr[1]);
        obj.disabled = false;
        notready = notready-1;
        if (arr[1] == "mode")
        {
            for (var i=0; i<vals.length;i++)
            {
                var t = arr[2].split('');
                document.getElementById(vals[i]).innerHTML = t[0];
            }
        }
	obj.value = arr[2];
	set_time(arr[3]);
    }
    else
    {
        alert(arr[0]);
    }
    set_run();
}

function set_val_fra(res)
{
    var arr = res.split("\\n");
    if (arr[0] == "OK" || arr[0] == "WARN")
    {
	if (arr[0] == "WARN")
	{
	    alert(arr[4]);
	}
        var obj = document.getElementById("fra_"+arr[1]);
        obj.disabled = false;
        notready = notready-1;
        if (arr[1] == "mode")
        {
            for (var i=0; i<vals.length;i++)
            {
                var t = arr[2].split('');
                document.getElementById(vals[i]).innerHTML = t[0];
            }
        }
	obj.value = arr[2];
	set_time(arr[3]);
    }
    else
    {
        alert(arr[0]);
    }
    set_run();
}

function set_segment(res)
{
    var arr = res.split("\\n");
    if (arr[0] == "OK" || arr[0] == "WARN")
    {
	if (arr[0] == "WARN")
	{
	    alert(arr[4]);
	}
        var obj = document.getElementById("fra_"+arr[1]);
        obj.disabled = false;
        notready = notready-1;
	var l = segs.length;
	for (var i = 0; i < l; i++)
	{
	    if (segs[i] != "")
	    {
		var myobj = document.getElementById(segs[i]);
		myobj.setAttribute("class","hidden");
		myobj.setAttribute("className","hidden");
		var a = segs[i].split("_");
		var inx = a.length;
		if (inx > 1 && a[inx-1] <= arr[2])
		{
		    myobj.setAttribute("className","textfield");
		    myobj.setAttribute("class","textfield");
		}
	    }
	}
	obj.value = arr[2];
	set_time(arr[3]);
    }
    else
    {
        alert(arr[0]);
    }
    set_run();
}

function change_val(element)
{
    var n = element.name;
    var val = element.value;
    element.disabled = true;
    notready = notready+1;
    set_run();
    run_ajax('change_config.cgi','&action=set_value&section=impedance_potentiostat&key='+n+'&value='+val,set_val);
}

function change_val_fra(element)
{
    var n = element.name;
    var val = element.value;
    element.disabled = true;
    notready = notready+1;
    set_run();
    run_ajax('change_config.cgi','&action=set_value&section=impedance_FRA&key='+n+'&value='+val,set_val_fra);
}

function change_segment(element)
{
    var n = element.name;
    var val = element.value;
    element.disabled = true;
    notready = notready+1;
    set_run();
    run_ajax('change_config.cgi','&action=set_value&section=impedance_FRA&key='+n+'&value='+val,set_segment);
}


</script>

END

}


sub advanced
{
    top_nav_bar_button('config.cgi','','','Manually edit configuration','s4');
    top_no_button();
    top_no_button();
    tab_newrow();
    js_back();
    top_js_return('#006600','white');
    top_nav_bar_button('','','','Simple setup','s6');
    ElchemeaCGI::create_menu_field;
    print start_form(-action=>'run_imp.cgi',-name=>'run_chrono',-class=>'form',-onsubmit=>'return check_run()');
    print_hidden();
    print submit(-name=>'action',-value=>'Run impedance',-class=>'none',-id=>'run_imp');
    print end_form;
    top_nav_bar_button('view_session.cgi','','','Session view','s6');
    top_nav_bar_button('main.cgi','','','To menu','s4');
    end_top_bar();
    my $pot = Elchemea::new_PSTAT(Elchemea::get_config_value('equipment','potentiostat'),Elchemea::get_config_value('equipment','potentiostat_address'));
    my $fra = Elchemea::new_FRA(Elchemea::get_config_value('equipment','FRA'),Elchemea::get_config_value('equipment','FRA_address'));
    print '<center>';
    print '<table cellspacing=5 cellpadding=5 class=tabel"><tr>';
    print '<td width="5%"></td>';
    print '<td width="17%"></td>';
    print '<td width="10%"></td>';
    print '<td width="3%"></td>';
    print '<td width="17%"></td>';
    print '<td width="10%"></td>';
    print '<td width="3%"></td>';
    print '<td width="17%"></td>';
    print '<td width="10%"></td>';
    print '<td width="3%"></td>';
    print '<td width="5%"></td>';
    print '</tr>';
    my @tags = ();
    my @yn = ('','Yes','No');
    my @offset_progs = Elchemea::get_dir_list('/usr/local/bin/elchemea/user_exec/','\w');
    unshift @offset_progs,'None';
    my $mode_pot = '';
    unless ($pot->virtual)
    {
	my $count = 0;
	my @list = $pot->setup_tags;
	my %setup = ();
	my @cf = ();
	foreach my $tag (@list,@cf)
	{
	    $tag .= '_program' if ($tag =~ /offset/);
	    $setup{$tag} = $user->get_config_value('impedance_potentiostat',$tag);
	    $setup{$tag} = $pot->get_default($tag) unless (defined($setup{$tag}));
	}
	$mode_pot = $setup{'mode'};
	print '<tr><td colspan=11 class="heading">Elchemea impedance setup potentiostat</td></tr>';
	foreach my $key (@cf,@list)
	{
	    my %labels = ();
	    print '<tr><td></td>' unless ($count);
	    print "<th onclick='get_desc(\"POT\",\"$key\")'>";
	    my $tag = $key;
	    $tag =~ s/_/ /g;
	    print ucfirst($tag);
	    print '</th><td>';
	    my @l = $pot->get_tag_values($key);
	    @l = $pot->get_modes() if ($key eq 'mode');
	    %labels = ('Volt' => 'Control Voltage', 'Amp' => 'Control current') if ($key eq 'mode');
	    @l = @offset_progs if ($key =~ /offset_prog/);
	    @l = @yn if ($key eq 'keep_potential');
	    if (@l>1 || $key eq 'mode' || $key =~ /offset_prog/)
	    {
		print popup_menu(-name=>$key,-values=>[(@l)],-class=>'textfield',-default=>$setup{$key},-force=>1,-onchange=>'change_val(this)',-id=>$key,-labels=>\%labels);
	    }
	    else
	    {
		print textfield(-name=>$key,-value=>$setup{$key},-class=>'textfield',-force=>1,-onchange=>'change_val(this)',-id=>$key);
	    }
	    print '</td><th id="pot_'.$key.'">';
	    $setup{'mode'} =~ /^(\w)/;
	    my $mk = $1;
	    $_ = $tag;
	  CASE:
	    {
		/polarisation$/ and do {print $mk;push @tags,"pot_$key";};
		/resis/i and do {print 'Ohm'};
		/range/i and do {print 'V'};
		/cur/i and do {print 'A'};
		/delay|time/ and do {print 's'};
	    }
	    print '</th>';
	    if ($count++ > 1)
	    {
		$count = 0;
		print '</tr>',"\n";
	    }
	}
    }
    print '<tr><td colspan=11 class="heading">Elchemea impedance setup frequency response analyser</td></tr>';
    my $count = 0;
    my @list = $fra->setup_tags;
    my @nl = ();
    foreach my $key (@list)
    {
#	next if ($key =~ /mode/ &&  $pot->virtual);
	next if ($key =~ /overhead/);
	push @nl,$key;
    }
    @list = @nl;
    my %setup = ();
    my @cf = ();
    foreach my $tag (@list,@cf)
    {
	$tag .= '_program' if ($tag =~ /offset/);
	$setup{$tag} = $user->get_config_value('impedance_FRA',$tag);
	$setup{$tag} = $fra->get_default($tag) unless (defined($setup{$tag}));
    }
    $setup{'mode'} = $mode_pot if ($mode_pot);
    foreach my $key (@cf,@list)
    {
        my %labels = ();
	print '<tr><td></td>' unless ($count);
	print "<th onclick='get_desc(\"FRA\",\"$key\")'>";
	my $tag = $key;
	$tag =~ s/_/ /g;
	print ucfirst($tag);
	print '</th><td>';
	my @l = $fra->get_tag_values($key);
	@l = $fra->get_modes() if ($key eq 'mode');
	%labels = ('Volt' => 'Control Voltage', 'Amp' => 'Control current') if ($key eq 'mode');
	@l = @offset_progs if ($key =~ /offset_prog/);
	@l = @yn if ($key eq 'keep_potential');
	if (@l>1 || $key eq 'mode' || $key eq 'source_mode' || $key =~ /offset_prog/)
	{
	    print popup_menu(-name=>$key,-values=>[(@l)],-class=>'textfield',-default=>$setup{$key},-force=>1,-onchange=>'change_val_fra(this)',-id=>'fra_'.$key,-labels=>\%labels);
	}
	else
	{
	    print textfield(-name=>$key,-value=>$setup{$key},-class=>'textfield',-force=>1,-onchange=>'change_val_fra(this)',-id=>'fra_'.$key);
	}
	print '</td><th id="label_fra_'.$key.'">';
	$setup{'mode'} =~ /^(\w)/;
	my $mk = $1;
	$_ = $tag;
      CASE:
	{
	    (/polarisation$/ && !$pot->virtual) and do {print 'V';};
	    (/polarisation$/ && $pot->virtual) and do {print $mk;push @tags,"label_fra_$key";};
	    /ampl/ and do {print $mk;push @tags,"label_fra_$key";};
	    /resis|^range$/i and do {print 'Ohm'; last CASE;};
            /range/i and do {print 'V'};
	    /cur/i and do {print 'A'};
	    /delay|time/ and do {print 's'};
	}
	print '</th>';
	if ($count++ > 1)
	{
	    $count = 0;
	    print '</tr>',"\n";
	}
    }


    print '</table>';
    print '</center>';

    my $valuearr = "var vals = [];\n";

    for (my $i = 0; $i < @tags; $i++ )
    {
        $valuearr .= 'vals['.$i.'] = "'.$tags[$i].'";'."\n";
    }

    print <<END;

<script language="javascript">


$valuearr

var notready = 0;
var running = 1;

function check_run()
{
    if (notready > 0)
    {
        return false;
    }
    if (running > 0)
    {
        return false;
    }
    return true;
}

function set_run()
{
    var obj = document.getElementById('run_imp');
    if (notready == 0 && running == 0)
    {
        obj.setAttribute("class","s3");
        obj.setAttribute("className","s3");
    }
    else
    {
        obj.setAttribute("class","none");
        obj.setAttribute("className","none");
    }
}

function set_status(s)
{
    var res = s.split("\\n");
    if (res[0] == "Free")
    {
        running = 0;
    }
    else
    {
        running = 1;
    }
    set_run();
}


function load_status()
{
    run_ajax('runstatus.cgi','&action=status',set_status);
    setTimeout("load_status()",1000);
}

function load_all()
{
    load_status();
}

function set_val(res)
{
    var arr = res.split("\\n");
    if (arr[0] == "OK" || arr[0] == "WARN")
    {
	if (arr[0] == "WARN")
	{
	    alert(arr[4]);
	}
        var obj = document.getElementById(arr[1]);
        obj.disabled = false;
        notready = notready-1;
        if (arr[1] == "mode")
        {
            for (var i=0; i<vals.length;i++)
            {
                var t = arr[2].split('');
                document.getElementById(vals[i]).innerHTML = t[0];
            }
        }
	obj.value = arr[2];
    }
    else
    {
        alert(arr[0]);
    }
    set_run();
}

function set_val_fra(res)
{
    var arr = res.split("\\n");
    if (arr[0] == "OK" || arr[0] == "WARN")
    {
	if (arr[0] == "WARN")
	{
	    alert(arr[4]);
	}
        var obj = document.getElementById("fra_"+arr[1]);
        obj.disabled = false;
        notready = notready-1;
        if (arr[1] == "mode")
        {
            for (var i=0; i<vals.length;i++)
            {
                var t = arr[2].split('');
                document.getElementById(vals[i]).innerHTML = t[0];
            }
        }
	obj.value = arr[2];
    }
    else
    {
        alert(arr[0]);
    }
    set_run();
}

function get_desc(dev,key)
{
    run_ajax('ajax_desc.cgi','&key='+key+'&device='+dev,alert);
}

function change_val(element)
{
    var n = element.name;
    var val = element.value;
    element.disabled = true;
    notready = notready+1;
    set_run();
    run_ajax('change_config.cgi','&action=set_value&section=impedance_potentiostat&key='+n+'&value='+val,set_val);
}

function change_val_fra(element)
{
    var n = element.name;
    var val = element.value;
    element.disabled = true;
    notready = notready+1;
    set_run();
    run_ajax('change_config.cgi','&action=set_value&section=impedance_FRA&key='+n+'&value='+val,set_val_fra);
}


</script>

END

}
