#!/usr/bin/perl -T
# $Id: keithley.cgi,v 1.3 2012/06/08 08:17:53 sqko Exp $
############################################################
############################################################
###                                                      ###
###   Originally designed by Karin Soeren Koch           ###
###                                                      ###
###   Impelemented by Soeren Koch                        ###
###                                                      ###
###   Copyright by Soeren Koch January 2005              ###
###                                                      ###
############################################################
############################################################

use strict;
use warnings;
use ElchemeaHeader;
use ElchemeaUser;
use Elchemea;
use Eurotherm;
use ElchemeaCGI qw(:DEFAULT :html :cgi);
use CGI qw(:standard :netscape);

if (param('ajax'))
{
    print header();
    unless (login_ok())
    {
        print "";
        exit;
    }
    my $user = ElchemeaUser->new(param('user'));
    my $a = param('action');
    if ($a eq 'new_channel')
    {
	my $section = 'datalog';
	my $name = get_CGI_value('value');
	if ($user->config_key_exists($section,'channel_'.$name))
	{
	    print "WARN\n$name\n\nChannel '$name' already exists!\n";
	    exit;
	}
	my $value = $user->get_config_value($section,'channel_'.$name);
	$user->change_config_value($section,'channel_'.$name,$value);
	print "OK\n$name\n";
	exit;
    }
    if ($a eq 'test_channel')
    {
	my $name = get_CGI_value('value');
	my $setup = $user->get_config_value('datalog',$name);
	my ($chid,$type) = split(/\,/,$setup);
	print Elchemea::socket_client('localhost','12345','K',$chid);
	exit;
    }
}


my $user;
my $bc_admin = undef;
if (!defined(param))
{
    print_header("Please log in to the Elchemea");
    print '<center>';
    &ElchemeaCGI::login;
    print '</center>';
    &print_end;
}
else
{
    if (login_ok())
    { 
	$user = ElchemeaUser->new(param('user'));
	&ElchemeaCGI::print_header("Datalogging channel setup",-onload=>'load_all()');   
	top_nav_bar_start();
	param(-name=>'action',-value=>'') unless (param('action'));
	$_ = param('action');
      CASE:
	{
	    ### Insert case statements ###
	    ### Default response ####
	    &main_page;
	}
	print_end();
    }
    else 
    {
	not_auth();
    }
}
    
exit;

sub main_page
{
    top_nav_bar_button('config.cgi','','','Manually edit configuration','s6');
    top_no_button();
    top_no_button();
    tab_newrow();
    js_back();
    top_js_return('#006600','white');
    top_no_button();
    top_nav_bar_button('misc.cgi','','','Miscelaneous setup','s3');
    top_no_button();
    top_nav_bar_button('main.cgi','','','To menu','s4');
    end_top_bar();
    my @channels = ('','cj_channel');
    my @keys = $user->config->get_keys('datalog');
    foreach (@keys)
    {
	push @channels,$_ if (/^channel_/);
    }
    my $pot = Elchemea::new_PSTAT(Elchemea::get_config_value('equipment','potentiostat'),Elchemea::get_config_value('equipment','potentiostat_address'));
    my $fra = Elchemea::new_FRA(Elchemea::get_config_value('equipment','FRA'),Elchemea::get_config_value('equipment','FRA_address'));
    print '<center>';
    print '<table cellspacing=5 cellpadding=5 class=tabel"><tr>';
    print '<td width="5%"></td>';
    print '<td width="17%"></td>';
    print '<td width="10%"></td>';
    print '<td width="3%"></td>';
    print '<td width="17%"></td>';
    print '<td width="10%"></td>';
    print '<td width="3%"></td>';
    print '<td width="17%"></td>';
    print '<td width="10%"></td>';
    print '<td width="3%"></td>';
    print '<td width="5%"></td>';
    print '</tr>';
    print start_form(-name=>'channel_select');
    print_hidden;
    print '<tr><td></td><th colspan=3> Select channel to configure </th><td>';
    print popup_menu(-name=>'channel',-values=>[@channels],-class=>'textfield',-onchange=>'document.channel_select.submit()');
    print '</td><td></td><td></td><td>';
    print button(-name=>'action',-value=>'New channel',-class=>'s3',-onclick=>'new_channel()');
    print '</td></tr>';
    print end_form();
    my @tags;
    my $name = get_CGI_value('channel');
    if ($name)
    {
	my $setup = $user->get_config_value('datalog',$name);
	my ($ch,$type) = ('','');
	($ch,$type) = split(/\s*\,\s*/,$setup) if ($setup);
	print "<tr><th colspan=11 class=heading> Configuring $name </th></tr>";
	print start_form(-name=>'chsetup');
	print '<tr><td></td><th> Channel </th><td>';
	print textfield(-name=>'ch',-value=>$ch,-force=>1,-onchange=>"change_setup('$name')",-id=>'ch');
	print '</td><th></th><th> Type </th><td>';
	print textfield(-name=>'type',-value=>$type,-force=>1,-onchange=>"change_setup('$name')",-id=>'type');
	print '</td><td></td><td>';
	print button(-name=>'Test '.$name,-class=>'s3',-onclick=>"test_channel('$name')");
	print '</td></tr>';
	print end_form();
    }
    print '</table>';
    print '</center>';

    my $valuearr = "var vals = [];\n";
    for (my $i = 0; $i < @tags; $i++ )
    {
        $valuearr .= 'vals['.$i.'] = "'.$tags[$i].'";'."\n";
    }

    print <<END;


<script language="javascript">

$valuearr

function change_setup(name)
{
    var ch = document.chsetup.ch.value;
    var tp = document.chsetup.type.value;
    var val = ch+','+tp;
    run_ajax('change_config.cgi','&action=set_value&section=datalog'+'&key='+name+'&value='+val,load_all);
}


function load_all()
{

}



function set_new_device(res)
{
    var name = '';
    var arr = res.split("\\n");
    if (arr[0] == "OK" || arr[0] == "WARN")
    {
        if (arr[0] == "WARN")
        {
            alert(arr[3]);
        }
        name = arr[2];
    }
    else
    {
        alert(arr[0]);
        return false;
    }
    var opt = document.createElement("option");
    opt.text = name;
    opt.value = name;
    document.channel_select.channel.add(opt);
    var idx = document.channel_select.channel.length - 1;
    document.channel_select.channel.selectedIndex = idx;
    document.channel_select.submit();
}

function new_channel()
{
    var text = prompt("New channel name:",'');
    if (text == null)
    {
        return false;
    }
    var reg = /^\\w+\$/;
    if (!reg.test(text))
    {
        alert("channel names must be a single string containing only alpahnumeric characters and no spaces!");
        return false;
    }
    run_ajax('keithley.cgi','&action=new_channel&value='+text,set_new_device);
}

function set_val(res)
{
    var arr = res.split("\\n");
    if (arr[0] == "OK")
    {
	var obj = document.getElementById(arr[1]);
	obj.disabled = false;
    }
    else
    {
	alert(arr[0]);
    }
}

function change_val(element,s)
{
    var n = element.name;
    var val = element.value;
    element.disabled = true;
    run_ajax('change_config.cgi','&action=set_value&section='+s+'&key='+n+'&value='+val,set_val);
}

function test_channel(val)
{
    run_ajax('keithley.cgi','&action=test_channel&value='+val,alert);
}


</script>

END

}
