#!/usr/bin/perl -T
# $Id: potsweep_conf.cgi,v 1.13 2013/08/27 12:17:54 sofc Exp $
############################################################
############################################################
###                                                      ###
###   Originally designed by Karin Soeren Koch           ###
###                                                      ###
###   Impelemented by Soeren Koch                        ###
###                                                      ###
###   Copyright by Soeren Koch January 2005              ###
###                                                      ###
############################################################
############################################################

use strict;
use warnings;
use ElchemeaHeader;
use ElchemeaUser;
use Elchemea;
use ElchemeaCGI qw(:DEFAULT :html :cgi);
use CGI qw(:standard :netscape);

my $user;
my $bc_admin = undef;
if (!defined(param))
{
    print_header("Please log in to the Elchemea");
    print '<center>';
    &ElchemeaCGI::login;
    print '</center>';
    &print_end;
}
else
{
    if (login_ok())
    { 
	$user = ElchemeaUser->new(param('user'));
	&ElchemeaCGI::print_header("Elchemea cyclic voltametry setup",-onload=>'load_all()');   
	top_nav_bar_start();
	param(-name=>'action',-value=>'') unless (param('action'));
	$_ = param('action');
      CASE:
	{
	    ### Insert case statements ###
	    ### Default response ####
	    &main_page;
	}
	print_end();
    }
    else 
    {
	not_auth();
    }
}
    
exit;

sub main_page
{
    top_nav_bar_button('config.cgi','','','Manually edit configuration','s6');
    top_no_button();
    top_no_button();
    tab_newrow();
    js_back();
    top_js_return('#006600','white');
    top_no_button();
    ElchemeaCGI::create_menu_field;
    print start_form(-action=>'run_potsweep.cgi',-name=>'run_chrono',-class=>'form',-onsubmit=>'return check_run()');
    print_hidden();
    print submit(-name=>'action',-value=>'Run potential sweep',-class=>'none',-id=>'run_potsweep_btn');
    print end_form;
    top_nav_bar_button('view_session.cgi','','','Session view','s6');
    top_nav_bar_button('main.cgi','','','To menu','s4');
    end_top_bar();
    my $pot = Elchemea::new_PSTAT(Elchemea::get_config_value('equipment','potentiostat'),Elchemea::get_config_value('equipment','potentiostat_address'));
    my $fra = Elchemea::new_FRA(Elchemea::get_config_value('equipment','FRA'),Elchemea::get_config_value('equipment','FRA_address'));
    print start_form(-name=>'main');
    print '<center>';
    print h1("Elchemea cyclic voltammetry setup");
    print '<table cellspacing=5 cellpadding=5 class=tabel"><tr>';
    print '<td width="5%"></td>';
    print '<td width="17%"></td>';
    print '<td width="10%"></td>';
    print '<td width="3%"></td>';
    print '<td width="17%"></td>';
    print '<td width="10%"></td>';
    print '<td width="3%"></td>';
    print '<td width="17%"></td>';
    print '<td width="10%"></td>';
    print '<td width="3%"></td>';
    print '<td width="5%"></td>';
    print '</tr>';
    my @points = ();
    foreach (1..$pot->max_sweep_points)
    {
	push @points , 'bias_point_'.$_;
    }
    my @cf = ();
    my @list = $pot->setup_tags_potsweep;
    my $last = pop(@list);
    push @list,'sleeptime';
    push @list,$last;
    my %setup = ();
    foreach my $tag (@list,@cf)
    {
        $tag .= '_program' if ($tag =~ /offset/);
        $setup{$tag} = $user->get_config_value('potsweep',$tag);
        $setup{$tag} = $pot->get_default($tag) unless (defined($setup{$tag}));
    }
    foreach my $tag (@points)
    {
        $setup{$tag} = $user->get_config_value('potsweep',$tag);
        $setup{$tag} = 0 unless (defined($setup{$tag}));
    }
    my $count = 0;
    my @tags = ();
    my @ptags = ();
    my @yn = ('','Yes','No');
    my @offset_progs = Elchemea::get_dir_list('/usr/local/bin/elchemea/user_exec/','\w');
    unshift @offset_progs,'None';
    my $graph = 0;
    foreach my $key (@list,@cf,@points)
    {
	next if ($key eq 'polarisation');
        print '<tr><td></td>' unless ($count);
        print "<th onclick='get_desc(\"POT\",\"$key\")'>";
        my $tag = $key;
        $tag = 'filter' if ($tag eq 'bandwidth');
        $tag =~ s/_/ /g;
        $tag =~ s/(.*\w)(time)/$1 $2/;
	$tag =~ s/bias point/potential/;
        print ucfirst($tag);
        print '</th><th>';
        my @l = $pot->get_tag_values($key);
        @l = @offset_progs if ($key =~ /offset_prog/);
        @l = @yn if ($key eq 'keep_potential');
	if ($tag eq 'mode')
	{
	    print 'Potential sweep';
	}
	else
	{
	    if (@l>1 || $key =~ /offset_prog/)
	    {
		print popup_menu(-name=>$key,-values=>[(@l)],-class=>'textfield',-default=>$setup{$key},-force=>1,-onchange=>'change_val(this)',-id=>$key);
	    }
	    else
	    {
		print textfield(-name=>$key,-value=>$setup{$key},-class=>'textfield',-force=>1,-onchange=>'change_val(this)',-id=>$key);
	    }
	}
        print '</th><th id="tag_'.$key.'">';
        $_ = $tag;
      CASE:
        {
            /polarisation$/ and do {print 'V'};
            /point/ and do {print 'V'};
	    /rate/ and do {print 'V/s'};
            /range/i and do {print 'V'};
            /resis/i and do {print 'Ohm'};
            /cur/i and do {print 'A'};
            /delay|time/ and do {print 's'};
        }
        print '</th>';
        if ($count++ > 1 || $key =~ /bias_point/i)
        {
	    if ($key =~ /bias_point/ && !$graph)
	    {
		print '<td colspan= 6 rowspan=6>';
		print '<img name="simimg" src="" id="psimimg">';
		print '</td>';
		$graph = 1;
	    }
            $count = 0;
            print '</tr>',"\n";
        }
    }
    my $valuearr = "var vals = [];\n";

    for (my $i = 0; $i < @tags; $i++ )
    {
        $valuearr .= 'vals['.$i.'] = "'.$tags[$i].'";'."\n";
    }
    $valuearr .= "var pvals = []\n";
    for (my $i = 0; $i < @ptags; $i++ )
    {
        $valuearr .= 'pvals['.$i.'] = "'.$ptags[$i].'";'."\n";
    }

    print '</table>';
    print h2({-id=>'psweep_time'},"Estimated time for potential sweep:");
    print '</center>';
    print end_form();



    print <<END;

<script language="javascript">


$valuearr

var notready = 0;
    var running = 1;

function check_run()
{
    if (notready > 0)
    {
        return false;
    }
    if (running > 0)
    {
        return false;
    }
    return true;
}

function set_run()
{
    var obj = document.getElementById('run_potsweep_btn');
    if (notready == 0 && running == 0)
    {
        obj.setAttribute("class","s3");
        obj.setAttribute("className","s3");
    }
    else
    {
        obj.setAttribute("class","none");
        obj.setAttribute("className","none");
    }
}

function set_status(s)
{
    var res = s.split("\\n");
    if (res[0] == "Free")
    {
        running = 0;
    }
    else
    {
        running = 1;
    }
    set_run();
}

function load_status()
{
    run_ajax('runstatus.cgi','&action=status',set_status);
    setTimeout("load_status()",1000);
}

function load_all()
{
    load_status();
    load_image()
}

function set_val(res)
{
    var arr = res.split("\\n");
    if (arr[0] == "OK" || arr[0] == "WARN")
    {
        if (arr[0] == "WARN")
        {
            alert(arr[4]);
        }
        var obj = document.getElementById(arr[1]);
        obj.disabled = false;
        notready = notready-1;
        if (arr[1] == "mode")
        {
            for (var i=0; i<vals.length;i++)
            {
                document.getElementById(vals[i]).innerHTML = arr[2];
            }
            for (var i=0; i<pvals.length;i++)
            {
                document.getElementById(pvals[i]).innerHTML = arr[2]+"/s";
            }
        }
        obj.value = arr[2];
    }
    else
    {
        alert(arr[0]);
    }
    load_image();
    set_run();
}


function load_image()
{
    run_ajax('potsim.cgi','&dummy=true',set_all);
}

function set_all(r)
{
    SetImage(r);
    set_time(r);
    set_run();
}

function get_desc(dev,key)
{
    run_ajax('ajax_desc.cgi','&key='+key+'&device='+dev,alert);
}

function change_val(element)
{
    var n = element.name;
    var val = element.value;
    element.disabled = true;
    notready = notready+1;
    set_run();
    run_ajax('change_config.cgi','&action=set_value&section=potsweep&key='+n+'&value='+val,set_val);
}

function SetImage(i)
{
    var arr = i.split("\\n");
    img = document.getElementById('psimimg');
    var src = arr[1]+'?'+Math.random();
    img.src = src;
}

function set_time(i)
{
    var arr = i.split("\\n");
    document.getElementById('psweep_time').innerHTML = "Estimated time for potential sweep: "+arr[0];
}

</script>

END

}
