#!/usr/bin/perl -T
# $Id: setup_program.cgi,v 1.13 2010/11/04 08:27:14 sofc Exp $
############################################################
############################################################
###                                                      ###
###   Originally designed by Karin Soeren Koch           ###
###                                                      ###
###   Impelemented by Soeren Koch                        ###
###                                                      ###
###   Copyright by Soeren Koch January 2005              ###
###                                                      ###
############################################################
############################################################

use strict;
use warnings;
use ElchemeaHeader;
use Elchemea;
use ElchemeaUser;
use SemaforeFile;
use ElchemeaCGI qw(:DEFAULT :html :cgi);
use CGI qw(:standard :netscape);
my $pot = Elchemea::new_PSTAT(Elchemea::get_config_value('equipment','potentiostat'),Elchemea::get_config_value('equipment','potentiostat_address'));
my $fra = Elchemea::new_FRA(Elchemea::get_config_value('equipment','FRA'),Elchemea::get_config_value('equipment','FRA_address'));
my $user;
my $file;
my $allow = 0;
my @headerlines = ('#!/usr/bin/perl','use ElchemeaProgram;','my $id = ElchemeaProgram->new(@ARGV);');
if (param('ajax'))
{
    print header();
    unless (login_ok())
    {
	print "";
	exit;	
    }
    my $a = param('action');
    if ($a && $a eq 'show')
    {
	my $user = param('user');
	my $session = param('session');
	my $file = param('file');
	my $f = $userdir.$user.'/'.$session.'/'.$file;
	exit unless (-e $f);
	$file = SemaforeFile->new($f);
	print join("\n",$file->readlines());
	exit;
    }
    if ($a && $a eq 'list')
    {
	my $user = param('user');
	my $session = param('session');
	my $dir = $userdir.$user.'/'.$session.'/';
	exit unless (-d $dir);
	my @filelist = Elchemea::get_dir_list($dir,".pl");
	unshift @filelist,'';
	print join("\n",@filelist);
	exit;
    }
    print "";
    exit;
}

if (!defined(param))
{
    print_header("Please log in to the Elchemea");
    print '<center>';
    &ElchemeaCGI::login;
    print '</center>';
    &print_end;
}
else
{
    if (login_ok())
    { 
	$user = ElchemeaUser->new(param('user'));
	my $filename = $userdir.$user->name.'/program.pl';
	my $cmd = "ps -efl | grep -P 'program_\\d+\\.pl ".$user->name."'";
	my $res = `$cmd`;
	$allow = 1 if ($res && $res =~ /\w+/);
	$file = SemaforeFile->new($filename);
	print_header("Elchemea main page");
	top_nav_bar_start();
	param(-name=>'action',-value=>'') unless (param('action'));
	$_ = param('action');
      CASE:
	{
	    ### Insert case statements ###

	    /Manually/ and do {&edit; print_end(); exit;};
	    /Save/ and do {&save; &edit; print_end(); exit;};
	    /Load old/ and do {&load_select; print_end; exit;};
	    /Use this/ and do {&load_final;};
	    /Clear program/ and do {&clear;};
	    /Delete first/ and do {&del_first;};
	    /Delete last/ and do {&del_last;};
	    /Add comment/ and do {$file->append('$id->proglog('."'".param('text')."'".');')};
	    /Run impedance/ and do {$file->append('$id->impedance('.&get_int('session').');')};
	    /Multiple/ and do {$file->append('$id->multi_imp('.&get_int('session').','.&get_int('number').','.&get_int('wait').');')};
	    /Run potential/ and do {$file->append('$id->potsweep('.&get_int('session').');')};
	    /Run chrono/ and do {$file->append('$id->chrono('.&get_int('session').','.&get_int('runtime').','.&get_float_or_ocv('pol').');')};
	    /Run baseline/ and do {$file->append('$id->chrono('.&get_int('session').',0,'.&get_float_or_ocv('pol').');')};
	    /Wait/ and do {$file->append('$id->wait('.&get_int('wait').');')};
	    /End chrono/ and do {$file->append('$id->end_chrono();')};
	    /End all/ and do {$file->append('$id->end_all();')};
	    /Reset/ and do {$file->append('$id->reset_potentiostat();')};
	    /Change channel/ and do {$file->append('$id->change_channel('.&get_int('channel').');')};
	    /Temperature/ and do {$file->append('$id->temp_and_ramp('.&get_int('temp').','.&get_int('ramp').');')};
	    last CASE if (-e $programlock);
	    ### Function calls below here is not possible durring program executeion ###
	    /Run program/ and do {&run_program; print_end; exit;};
	}   /Stop program/ and do {&stop_program; print_end; exit;};
	### Default response ####
	&main_page;
	print_end();
    }
    else 
    {
	not_auth();
    }
}
    
exit;

sub stop_program()
{
    top_nav_bar_button('','','','Return to setup','s3');
    top_no_button();
    top_no_button();
    tab_newrow();
    js_back();
    top_js_return('#006600','white');
    top_no_button();
    top_no_button();
    top_no_button();
    top_nav_bar_button('main.cgi','','','To menu','s4');
    end_top_bar();
    $user->proglog('Stopping running program!');
    return unless ($allow);
    eval {
	my $res = Elchemea::CGI_client('stop_program');
	my $res2 = Elchemea::CGI_client('stop_measure');
	if ($res && $res2)
	{
	    print center(h1('Program and measurements terminated'));
	}
	else
	{
	    print center(h1({-class=>'Alert'},"Program could not be stopped"));
	}
    };
    if ($@)
    {
	print center(h1({-class=>'Alert'},"Program could not be stopped: $@"));
    }
}


sub run_program()
{
    top_nav_bar_button('','','','Return to setup','s3');
    top_no_button();
    top_no_button();
    tab_newrow();
    js_back();
    top_js_return('#006600','white');
    top_no_button();
    top_no_button();
    top_no_button();
    top_nav_bar_button('main.cgi','','','To menu','s4');
    end_top_bar();
    eval {
	my $res = Elchemea::CGI_client('run_program',$user->name);
	if ($res)
	{
	    print center(h1('Program '.$res.' startet'));
	    return;
	}
	else
	{
	    print center(h1({-class=>'Alert'},"Program could not be startet"));
	}
    };
    if ($@)
    {
	print center(h1({-class=>'Alert'},"Program could not be startet: $@"));
    }
}

sub load_final()
{
    my $session = param('session');
    chomp $session;
    my $fname = param('filename');
    chomp $fname;
    my $fn = $userdir.$user->name.'/'.$session.'/'.$fname;
    return unless (-e $fn);
    my $f = SemaforeFile->new($fn);
    my @lines = $f->readlines();
    $file->writeline(@lines);
}

sub get_int($)
{
    my $tag = shift;
    my $val = param($tag);
    if ($val =~ /(\d+)/)
    {
	return $1;
    }
    return undef;
}

sub get_float($)
{
    my $tag = shift;
    my $val = param($tag);
    if ($val =~ /([\d\.\-\+eE]+)/)
    {
	return $1;
    }
    return undef;
}

sub get_float_or_ocv($)
{
    my $tag = shift;
    my $val = param($tag);
    if ($val =~ /([\d\.\-\+eE]+)/)
    {
	return $1;
    }
    if ($val =~ /ocv/i)
    {
	return "'ocv'";
    }
    return undef;
}

sub save()
{
    my $prg = param('program');
    return unless ($prg);
    my @lines = split(/\n/,$prg);
    $file->writeline(@lines);
}

sub load_select()
{
    top_nav_bar_button('','','','Return to setup','s3');
    top_no_button();
    top_no_button();
    tab_newrow();
    js_back();
    top_js_return('#006600','white');
    top_no_button();
    top_no_button();
    top_no_button();
    top_nav_bar_button('main.cgi','','','To menu','s4');
    end_top_bar();
    my @sessions = (1..$user->session);
    my $dir = $userdir.$user->name.'/'.$user->session.'/';
    my @filelist = Elchemea::get_dir_list($dir,".pl");
    unshift @filelist,'';
    print '<center>';
    print '<table border=0 cellspacing=5 cellpadding=0 style="width:100%"><tr>';
    print '<td width="1%"></td>';
    print '<td width="29%"></td>';
    print '<td width="69%"></td>';
    print '<td width="1%"></td>';
    print '</tr>';
    print '<tr><td colspan=4 class="heading">';
    print "Select program to load";
    print '</td></tr>';
    print '<tr><td></td><td valign=top>';
    print start_form(-class=>'form',-name=>'program');
    print textarea(-name=>'test',-value=>'',-class=>'textfield',-rows=>'25',-force=>'1',-wrap=>'OFF');
    print end_form();
    print '</td><td valign=top>';

    print '<table border=0 cellspacing=2 cellpadding=0 style="width:100%">';
    print '<tr height=40px>';
    print '<td width=5%></td>';
    print '<td width=30%></td>';
    print '<td width=5%></td>';
    print '<td width=55%></td>';
    print '<td width=5%></td>';
    print '</tr>'; 
    print start_form(-class=>'form',-name=>'select',-onsubmit=>'return confirm("Replace current program with selected program")');
    print_hidden();
    print '<tr><td></td><td class="heading">Selcet session</td><td></td><td>';
    print popup_menu(-name=>'session',-values=>[(@sessions)],-class=>'textfield',-default=>$user->session(),-force=>1,-onchange=>'load_progs(this);');
    print '</td></tr>';
    print '<tr><td height=40></td></tr>';
    print '<tr><td></td><td class="heading">Selcet program</td><td></td><td>';
    print popup_menu(-name=>'filename',-values=>[(@filelist)],-class=>'textfield',-default=>'',-force=>1,-onchange=>'select_prog(this);');
    print '</td></tr>';
    print '<tr><td height=40></td></tr>';
    print '<tr><td colspan=3></td><td>';
    print submit(-name=>'action',-value=>'Use this program',-class=>'s3');
    print '</td></tr>';
    print end_form();
    print '</table>';
    print '</td></tr></table>';
    print '</center>';
    my $s = $user->session;
    print <<END;

<script language="javascript">

function set_list(t)
{
    document.program.test.value = '';
    var list = document.select.filename;
    var arr=t.split("\\n");
    var len = arr.length-1;
    for (var i = 0; i<len; i++)
    {
        var optn = document.createElement("OPTION");
	optn.value = arr[i];
	optn.text = arr[i];
	list.options.add(optn);
    }
}

function load_progs(element)
{
    var ses = element[element.selectedIndex].value;
    document.select.filename.length = 0;
    run_ajax('setup_program.cgi','&action=list&session='+ses,set_list);
}

function set_prog(t)
{
    document.program.test.value = t;
}

function select_prog(element)
{
    var prog = element[element.selectedIndex].value;
    var ses = document.select.session[document.select.session.selectedIndex].value;
    run_ajax('setup_program.cgi','&action=show&session='+ses+'&file='+prog,set_prog);
}

</script>

END

}

sub edit()
{
    top_no_button();
    top_nav_bar_button('','','','Return to setup','s3');
    top_no_button();
    tab_newrow();
    js_back();
    top_js_return('#006600','white');
    top_no_button();
    top_no_button();
    top_no_button();
    top_nav_bar_button('main.cgi','','','To menu','s4');
    end_top_bar();
    my $config = join("\n",$file->readlines());
    print '<center>';
    print h1("Elchemea configuration");
    print start_form(-name=>'changecfg');
    print_hidden();
    print '<table border=0 cellspacing=0 cellpadding=0>';
    print '<tr><td>';
    print textarea(-name=>'program',-value=>$config,-force=>1,-rows=>20,-cols=>70);
    print '</td></tr><tr><td>';
    print submit(-name=>'action',-value=>'Save program',-class=>'s3');
    print '</td></tr>';
    print '</table>';
    print end_form();
    print '</center>';
}

sub del_first()
{
    return if (-e $programlock);
    my $nr = scalar(@headerlines);
    my @lines = @headerlines;
    @lines = $file->readlines() if ($file->exist);
    return unless (@lines > $nr);
    my @content = splice(@lines,$nr+1);
    $file->writeline(@headerlines,@content);
}

sub del_last()
{
    return if (-e $programlock);
    my $nr = scalar(@headerlines);
    my @lines = @headerlines;
    @lines = $file->readlines() if ($file->exist);
    return unless (@lines > $nr);
    pop(@lines);
    $file->writeline(@lines);
}

sub clear()
{
    return if (-e $programlock);
    $file->writeline(@headerlines);
}


sub main_page
{
    if (-e $programlock && $allow)
    {
	&is_running();
	return;
    }
    top_nav_bar_button('','','action','Load old program','s5');
    if (get_config_value('global','allow_manual_edit') && get_config_value('global','allow_manual_edit') =~ /yes/i)
    {
	top_nav_bar_button('','','action','Manually edit program','s6');
    }
    else
    {
	top_no_button();
    }
    top_no_button();
    tab_newrow();
    js_back();
    top_js_return('#006600','white');
    top_nav_bar_button('','','action','Clear program','s0');
    top_nav_bar_button('','','action','Delete first line','s1');
    top_nav_bar_button('','','action','Delete last line','s1');
    top_nav_bar_button('main.cgi','','','To menu','s4');
    end_top_bar();
    ### Get time for current program ###
    my $cmd = '/usr/bin/perl '.$file->filename.' '.$user->name.' test';
    my $progtime = `$cmd`;
    chomp $progtime;
    ### Get any compiletime errors for program (by calling it again with redirect)
    $cmd = '/usr/bin/perl '.$file->filename.' '.$user->name.' test 2>&1 1>/dev/null';
    my $err = `$cmd`;
    chomp $err;
    my @lines = @headerlines;
    my $nr = scalar(@headerlines);
    @lines = $file->readlines() if ($file->exist);
    if (@lines < @headerlines)
    {
	### In case of empty or short file: reset file ###
	$file->writeline(@headerlines);
	@lines = @headerlines;
    }
    my $content = join("\n",splice(@lines,$nr));
    print '<center>';
    print '<table border=0 cellspacing=5 cellpadding=5 style="width:100%"><tr>';
    print '<td width="1%"></td>';
    print '<td width="24%"></td>';
    print '<td width="74%"></td>';
    print '<td width="1%"></td>';
    print '</tr>';
    print '<tr><td colspan=4 class="heading">';
    if (-e $programlock)
    {
	print "Setup sequential program (Program can not be started as a program started by an other user is already running!)";
    }
    else
    {
	print "Setup sequential program";
    }
    print '</td></tr>';
    print '<tr><td></td><td valign=top>';
    print start_form(-class=>'form');
    print_hidden();
    print h3('Current program:');
    print textarea(-name=>'test',-value=>$content,-class=>'textfield',-rows=>'20',-force=>'1',-wrap=>'OFF',-onfocus=>'this.blur()');
    menu_button('action','Run program','s2') unless (-e $programlock);
    print end_form();
    print '</td><td valign=top>';
    print '<table border=0 cellspacing=2 cellpadding=2 style="width:100%">';
    print '<tr height=0px>';
    print '<td width=25%></td>';
    print '<td width=5%></td>';
    print '<td width=10%></td>';
    print '<td width=5%></td>';
    print '<td width=10%></td>';
    print '<td width=5%></td>';
    print '<td width=15%></td>';
    print '<td width=5%></td>';
    print '<td width=20%></td>';
    print '</tr>'; 
    print start_form(-class=>'form');
    print '<tr><td>';
    print_hidden();
    menu_button('action','Add comment','s3');
    print '</td><td colspan=8>';
    print textfield(-name=>'text',-value=>'',-force=>'1',-class=>'textfield');
    print '</td></tr>';
    print end_form;
    print start_form(-class=>'form');
    print '<tr><td>';
    print_hidden();
    menu_button('action','Wait for','s3');
    print '</td><td colspan=1>';
    print textfield(-name=>'wait',-value=>5,-force=>'1',-class=>'textfield',-onchange=>"is_int(this)");
    print '</td><th>minutes</th></tr>';
    print end_form;
    unless ($fra->virtual)
    {
	print start_form(-class=>'form');
	print '<tr><td>';
	print_hidden();
	menu_button('action','Run impedance','s3');
	print '</td><th colspan=2>Configuration:</th><td colspan=1>';
	print textfield(-name=>'session',-value=>$user->session,-force=>'1',-class=>'textfield',-onchange=>"is_int(this)");
	print '</td></tr>';
	print end_form;
	print start_form(-class=>'form');
	print '<tr><td>';
	print_hidden();
	menu_button('action','Multiple impedance','s4');
	print '</td><th colspan=2>Configuration:</th><td colspan=1>';
	print textfield(-name=>'session',-value=>$user->session,-force=>'1',-class=>'textfield',-onchange=>"is_int(this)");
	print '</td><th> number:</th><td>';
	print textfield(-name=>'number',-value=>'5',-force=>'1',-class=>'textfield',-onchange=>"is_int(this)");
	print '</td><th> wait between:</th><td>';
	print textfield(-name=>'wait',-value=>'5',-force=>'1',-class=>'textfield',-onchange=>"is_int(this)");
	print '</td><th> minutes </th></tr>';
	print end_form;
    }
    unless ($pot->virtual)
    {
	print start_form(-class=>'form');
	print '<tr><td>';
	print_hidden();
	menu_button('action','Run potential sweep','s3');
	print '</td><th colspan=2>Configuration:</th><td colspan=1>';
	print textfield(-name=>'session',-value=>$user->session,-force=>'1',-class=>'textfield',-onchange=>"is_int(this)");
	print '</td></tr>';
	print end_form;
	print start_form(-class=>'form');
	print '<tr><td>';
	print_hidden();
	menu_button('action','Run chrono','s3');
	print '</td><th colspan=2>Configuration:</th><td colspan=1>';
	print textfield(-name=>'session',-value=>$user->session,-force=>'1',-class=>'textfield',-onchange=>"is_int(this)");
	print '</td><th> time (minutes):</th><td>';
	print textfield(-name=>'runtime',-value=>'5',-force=>'1',-class=>'textfield',-onchange=>"is_int(this)");
	print '</td><th>Polarisation:</th><td>';
	print textfield(-name=>'pol',-value=>'0',-force=>'1',-class=>'textfield',-onchange=>"is_float_or_ocv(this)");
	print '</td><th> Volt or A depending on configuration</th></tr>';
	print end_form;
	print start_form(-class=>'form');
	print '<tr><td>';
	print_hidden();
	menu_button('action','Run baseline chrono','s2');
	print '</td><th colspan=2>Configuration:</th><td colspan=1>';
	print textfield(-name=>'session',-value=>$user->session,-force=>'1',-class=>'textfield',-onchange=>"is_int(this)");
	print '</td><th colspan=2></th><th>Polarsiation </th><td>';
	print textfield(-name=>'pol',-value=>'0',-force=>'1',-class=>'textfield',-onchange=>"is_float_or_ocv(this)");
	print '</td><th> Volt or A depending on configuration</th></tr>';
	print end_form;
	print start_form(-class=>'form');
	print '<tr><td>';
	print_hidden();
	menu_button('action','End chrono','s1');
	print '</td><th colspan=8> Ends any running baseline chrono amperometry/potentiometry measurement</th></tr>';
	print end_form;
	print start_form(-class=>'form');
	print '<tr><td>';
	print_hidden();
	menu_button('action','Reset potentiostat','s4');
	print '</td><th colspan=8> Resets potentiostat to OCV conditions </th></tr>';
	print end_form;
    }
    if (get_config_value('equipment','parallel_port_controler') && get_config_value('equipment','parallel_port_controler') =~ /yes/i)
    {
	my @channels = (0,1,2,3);
	my $chid = get_config_value('equipment','parallel_port_channels');
	@channels = split(/\,/,$chid) if ($chid);
	print start_form(-class=>'form');
	print '<tr><td>';
	print_hidden();
	menu_button('action','Change channel','s3');
	print '</td><th colspan=4> to multiplexer chanel:</th><td colspan=1>';
	print popup_menu(-name=>'channel',-values=>[(@channels)],-class=>'textfield');
	print '</td></tr>';
	print end_form;
    }
    print start_form(-class=>'form');
    print '<tr><td>';
    print_hidden();
    menu_button('action','Temperature and ramp','s4');
    print '</td><th colspan=2>Temperature:</th><td colspan=1>';
    print textfield(-name=>'temp',-value=>25,-force=>'1',-class=>'textfield',-onchange=>"is_int(this)");
    print '</td><th> Ramp:</th><td>';
    print textfield(-name=>'ramp',-value=>60,-force=>'1',-class=>'textfield',-onchange=>"is_int(this)");
    print '</td><th> C/hour:</th></tr>';
    print end_form;
    print start_form(-class=>'form');
    print '<tr><td>';
    print_hidden();
    menu_button('action','End all','s1');
    print '</td><th colspan=8> Ends all measurements and programs</th></tr>';
    print end_form;
    if ($err)
    {
	print '<tr><th colspan=7 style="color:red;">';
	print $err;
	print '</th></tr>',
    }
    else
    {
	print '<tr><td colspan=5 class="heading">';
	print 'Total time for program execution: </td><td colspan=2 class="heading">';
	print Elchemea::format_time($progtime);
	print '</td></tr>',
    }
    print '</table>';
    print '</td></tr>';
    print '</table>';
}


sub is_running()
{
    my $content = join("\n",$file->readlines());
    top_nav_bar_button('','','','Return to setup','s3');
    top_no_button();
    top_no_button();
    tab_newrow();
    js_back();
    top_js_return('#006600','white');
    top_no_button();
    top_no_button();
    top_no_button();
    top_nav_bar_button('main.cgi','','','To menu','s4');
    end_top_bar();
    print '<center>';
    print '<table border=0 cellspacing=5 cellpadding=0 style="width:100%"><tr>';
    print '<td width="10%"></td>';
    print '<td width="40%"></td>';
    print '<td width="40%"></td>';
    print '<td width="10%"></td>';
    print '</tr>';
    print '<tr><td colspan=4 class="heading">';
    if ($allow)
    {
	print "Program is currently running";
    }
    else
    {
	print "A program started by an other user is currently running";
    }
    print '</td></tr>';
    print '<tr><td></td><td valign=top>';
    print start_form(-class=>'form',-name=>'program');
    print textarea(-name=>'test',-value=>$content,-class=>'textfield',-rows=>'25',-force=>'1',-wrap=>'OFF') if ($allow);
    print end_form();
    print '</td><td valign=top>';

    print '<table border=0 cellspacing=2 cellpadding=0 style="width:100%">';
    print '<tr height=40px>';
    print '<td width=5%></td>';
    print '<td width=30%></td>';
    print '<td width=5%></td>';
    print '<td width=55%></td>';
    print '<td width=5%></td>';
    print '</tr><td><td colspan=3>'; 
    print start_form(-class=>'form',-name=>'select',-onsubmit=>'return confirm("Stop current running program")');
    print_hidden();
    print submit(-name=>'action',-value=>'Stop program',-class=>'s3') if ($allow);
    print '</td></tr>';
    print end_form();
    print '</table>';
    print '</td></tr></table>';
    print '</center>';

}
